import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class PrimApplet extends JApplet implements ActionListener {
	private JLabel lblTitle, lblInput, lblResult;
	private JTextField tfInput;	
    private JButton cbTest;

    public void init() {
    	Container cont = getContentPane();
		JPanel panCenter = new JPanel();
		cont.add(panCenter, BorderLayout.CENTER);

		JPanel panTitle = new JPanel();		
		lblTitle = new JLabel("Primzahlendiagnose");
		panTitle.add(lblTitle);
		panTitle.setAlignmentX(Component.CENTER_ALIGNMENT);
		lblTitle.setFont(new Font("Arial", Font.BOLD, 16));
		cont.add(panTitle, BorderLayout.NORTH);
		
		lblInput = new JLabel("Argument:");
		panCenter.add(lblInput);
		tfInput = new JTextField("", 20);
		panCenter.add(tfInput);
		cbTest = new JButton("P-Test");
		panCenter.add(cbTest);
		cbTest.addActionListener(this);
		
		JPanel panResult = new JPanel();		
		lblResult = new JLabel("");
		panResult.setAlignmentX(Component.CENTER_ALIGNMENT);
		panResult.add(lblResult);
		add(panResult, BorderLayout.SOUTH);
	}

	public void actionPerformed(ActionEvent e) {
		boolean tg;
		long i, mtk, zahl;
		
		try {
			zahl = Long.parseLong(tfInput.getText());
		} catch(Exception ex) {
			lblResult.setText("Das Argument ist keine ganze Zahl mit Betrag < 9223372036854775808.");
			return;
		}
		if (zahl < 2) {
			lblResult.setText("Es sind nur Argumente > 1 zugelassen.");
			return;
		}
		tg = false;
		mtk = (long) Math.sqrt(zahl);  //maximaler Teilerkandidat
		for (i = 2; i <= mtk; i++)
			if (zahl % i == 0) {
				tg = true;
				break;
			}
		if (tg)
			lblResult.setText(tfInput.getText() + " ist keine Primzahl (Teiler: " + i + ").");
		else
			lblResult.setText(tfInput.getText() + " ist eine Primzahl.");
	}
}