import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

class DbFrontend extends JFrame {
	static final String TITEL = "Tabellen der Firmendatenbank";
	static final String DRIVER = "";
	static final String URL = "jdbc:derby:../Firma";
	static final String USERID = "";
	static final String PASSWD = "";
	static final String[] TABLES = {"Personal", "Kunden", "Auftraege", "Einsaetze"};
	
	private JComboBox list;
	private JTable table;
	private ResultSetTableModel tabMod;
	
	public DbFrontend() {
		super(TITEL);
		try {
			list = new JComboBox(TABLES);
			list.setEditable(false); 
			list.addItemListener(
					new ItemListener() {
						public void itemStateChanged(ItemEvent e) {
							JComboBox cb = (JComboBox) e.getSource();
							tabMod.newQuery(cb.getSelectedItem().toString());
						}
					});
	 
			tabMod = new ResultSetTableModel(DRIVER, URL, USERID, PASSWD, TABLES[0]);
			table = new JTable(tabMod);
		    
			add(list, BorderLayout.NORTH);
			add(new JScrollPane(table), BorderLayout.CENTER);
	
			setSize(800, 200);
			setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
			addWindowListener(new Ex());
			setVisible(true);
		} catch (Exception e) {
			JOptionPane.showMessageDialog(this, e);
			System.exit(1);
		}
	}
	public static void main(String args[]) {
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				new DbFrontend();
			}
		});
	}

	private class Ex extends WindowAdapter {
		public void windowClosing(WindowEvent e) {
			tabMod.disconnect();
			System.exit(0);
		}
	}
}
