import java.io.*;

class BufferedOutputStreamFile {
	final static long ANZAHL = 500_000;
	public static void main(String[] args) {
		long time;

		try (FileOutputStream fos = new FileOutputStream("Buffer.dat")) {
			time = System.currentTimeMillis();
			for (int i = 1; i <= ANZAHL; i++)
				fos.write(0);
			System.out.println("Zeit fuer die ungepufferte Ausgabe: " +
					(System.currentTimeMillis() - time));
		} catch (IOException ioe) {
			System.err.println(ioe);
		}
		
		try (BufferedOutputStream bos = new BufferedOutputStream(new FileOutputStream("Buffer.dat"), 8192)) {
			time = System.currentTimeMillis();
			for (int i = 1; i <= ANZAHL; i++)
				bos.write(i);
			System.out.println("Zeit fuer die gepufferte Ausgabe:   " +
					(System.currentTimeMillis() - time));
		} catch (IOException ioe) {
			System.err.println(ioe);
		}
	}
}