import java.io.*;
import java.nio.charset.Charset;
import java.nio.file.Files;
import java.nio.file.Paths;

class BufferedWriterDemo {
	public static void main(String[] args) throws IOException {
		final long anzahl = 5_000_000;

		try (PrintWriter pw = new PrintWriter(new FileWriter("test1.txt"))) {
			long time = System.currentTimeMillis();
			for (int i = 1; i <= anzahl; i++)
				pw.println("Zeile " + i);
			System.out.println("Benoetigte Zeit beim Warmlaufen:            "
					+(System.currentTimeMillis()-time));
		}

		try (PrintWriter pw = new PrintWriter(new FileWriter("test2.txt"))) {
			long time = System.currentTimeMillis();
			for (int i = 1; i <= anzahl; i++)
				pw.println("Zeile " + i);
			System.out.println("Benoetigte Zeit ohne BufferedWriter:        "
					+(System.currentTimeMillis()-time));
		}

		try (PrintWriter pw =  new PrintWriter(new BufferedWriter(new FileWriter("test3.txt")))) {
			long time = System.currentTimeMillis();
			for (int i = 1; i <= anzahl; i++)
				pw.println("Zeile " + i);
			System.out.println("Benoetigte Zeit mit BufferedWriter:         "
					+(System.currentTimeMillis()-time));
		}

		try (PrintWriter pw =  new PrintWriter(
				Files.newBufferedWriter(Paths.get("test4.txt"), Charset.defaultCharset()))) {
			long time = System.currentTimeMillis();
			for (int i = 1; i <= anzahl; i++)
				pw.println("Zeile " + i);
			System.out.println("Benoetigte Zeit mit BufferedWriter (NIO2.): "
					+(System.currentTimeMillis()-time));
		}
	
	}
}