import java.io.*;
import java.io.IOException;
import java.util.*;

public class DataMatrix {
	private String[] names;
	private double[][] data;

	public boolean readData(String fileName) {
		try (BufferedReader br = new BufferedReader(new FileReader(fileName))) {
			String line = br.readLine();
			StringTokenizer stok = new StringTokenizer(line, " \t", false);
			int j = stok.countTokens(); 
			names = new String[j];
	
			for (int n = 0; n < j; n++)
				names[n] = stok.nextToken();
	
			ArrayList<double[]> tempData = new ArrayList<double[]>();
			
			int i = 0;
			Scanner scanner;
			double[] da;
			while ((line = br.readLine()) != null) {
				i++;
				scanner = new Scanner(line);
				da = new double[j];
				for (int n = 0; n < j; n++)
					if (scanner.hasNextDouble()) 
						da[n] = scanner.nextDouble();
					else
						return false;
				tempData.add(da);
			}
			data = new double[i][j];
			Iterator<double[]> iterator = tempData.iterator(); 
			for (int m = 0; m < i; m++)
				data[m] = iterator.next();
			return true;
		} catch (IOException ioe) {
			System.out.println(ioe.getMessage());
			return false;
		}
	}

	public void printData() {
		if (data != null) {
			for (int n = 0; n < names.length; n++)
				System.out.printf("%10s", names[n]);
				System.out.println();
			for (int m = 0; m < data.length; m++) {
				for (int n = 0; n < names.length; n++)
					System.out.printf("%10.2f", data[m][n]);
				System.out.println();
			}
		}
	}
	
	public static void main(String[] args) {
		DataMatrix dm = new DataMatrix();
		if (dm.readData("test.txt"))
			dm.printData();
		else
			System.out.println("Fehler beim Lesen der Daten");
	}
}
