// Das Programm demonstriert die Verwendung der Klassen FileInputStream und FileOutputStream.
// Zum Erstellen einer Dateikopie in Java 7 sollte man jedoch eine copy()-Methode der Klasse Files verwenden.

import java.io.*;

class FileCopy {
	public static void main(String[] args) {
		String quelle = "quelle.dat", ziel = "ziel.dat";
		final int buflen = 1048576; // Ein Megabyte (1024 * 1024 Bytes)
		byte[] buffer = new byte[buflen];
		int nread;
		long zeit, total = 0;
		try (FileInputStream  fis = new FileInputStream(quelle); FileOutputStream fos = new FileOutputStream(ziel)) {
			zeit = System.currentTimeMillis();
			System.out.println("Kopieren von "+quelle+" in "+ziel+ " gestartet:");
			while (true) {
				nread = fis.read(buffer, 0, Math.min(buflen, fis.available()));
				if (nread == 0)
					break;
				else {
					fos.write(buffer, 0, nread);
					total += nread;
					System.out.print("*");
				}
			}
			zeit = System.currentTimeMillis() - zeit;
			System.out.println("\nEs wurden "+total+" Bytes kopiert. "+
					"(Benoetigte Zeit: "+zeit+" Millisekunden.)");
		} catch (IOException e) {
			System.err.println(e.getMessage());
		}
	}
}