import java.io.IOException;
import java.nio.file.*;

class FilesCopy {
	public static void main(String[] args) {
		Path quelle = Paths.get("quelle.dat");
		Path ziel = Paths.get("ziel.dat");
		try {
			long zeit = System.currentTimeMillis();
			System.out.println("Kopieren von "+quelle+" in "+ziel+ " gestartet:");
			Files.copy(quelle, ziel, StandardCopyOption.REPLACE_EXISTING);
			zeit = System.currentTimeMillis() - zeit;
			System.out.println("\nEs wurden " + Files.size(quelle) + " Bytes kopiert. "+
					"(Benoetigte Zeit: " + zeit + " Millisekunden.)");
		} catch (IOException e) {
			System.err.println(e.getMessage());
		}
	}
}