import java.io.*;
import java.nio.file.*;

class OpenOptionDemo {
	public static void main(String[] args) {
		byte[] arr1 = {0,1,2,3};
		Path file = Paths.get("demo.txt");
		
		try (OutputStream os = Files.newOutputStream(file)) {
			os.write(arr1);
		} catch (IOException ioe) {
			System.err.println(ioe);
		}

		byte[] arr2 = {4,5,6};
		try (OutputStream os = Files.newOutputStream(file, StandardOpenOption.CREATE)) {
			os.write(arr2);
		} catch (IOException ioe) {
			System.err.println(ioe);
		}

		byte[] arr = new byte[8];
		try (InputStream is = Files.newInputStream(file)) {
			is.read(arr);
			for (int i : arr)
				System.out.println(i);
		} catch (IOException ioe) {
			System.err.println(ioe);
		}
	}
}
