public class GenMax {
	public static <T extends Comparable<T>> T max(T x, T y) {
		return x.compareTo(y) > 0 ? x : y;
	}

	public static <T extends Comparable<T>> T max(T ... aa) {
		if (aa == null)
			return null;
		for (T t : aa)
			if (t == null)
				return null;
		int actMax = 0, actKand = 1;
		while (actKand < aa.length) {
			if (aa[actMax].compareTo(aa[actKand]) < 0)
				actMax = actKand;
			actKand++;
		}
		return aa[actMax];
	}

	public static void main(String[] args) {
		System.out.println("Max. von int-Serie\t"+max(4, 777, 11, 81));
		System.out.println("Max. von double-Serie\t"+max(4.0, 777.0, 11.0, 81.0));

		int[] ia = {4, 777, 11, 81};
		Integer[] iaw = new Integer[4];
		for (int i = 0; i < ia.length; i++)
			iaw[i] = ia[i];
		System.out.println("Max. von Integer-Array\t"+max(iaw));
		
		Integer[] iarr = {11, 7, 4, 45, 5};
		System.out.println("Max. Elem. im Integer-Array: "+max(iarr));
	}
}
