import java.util.Arrays;

public class SimpleList<E> {
	private Object[] elements;
	private final int DEF_INIT_SIZE = 16;
	private int initSize;
	private int size;
	
	public SimpleList(int len) {
		if (len > 0) {
			initSize = len;
			elements = new Object[len];
		} else {
			initSize = DEF_INIT_SIZE;
			elements = new Object[DEF_INIT_SIZE];
		}
	}
	
	public SimpleList() {
		initSize = DEF_INIT_SIZE;
		elements = new Object[DEF_INIT_SIZE];
	}
	
	public void add(E element) {
		if (size ==  elements.length)
			elements = Arrays.copyOf(elements, elements.length + initSize);
		elements[size++] = element;
	}

	public E get(int index) {
		if (index >= 0 && index < size)
			return (E) elements[index];
		else
			return null;
	}
	
//	public E get(int index) {
//	if (index >= 0 && index < size) {
//		@SuppressWarnings("unchecked") E result = (E) elements[index]; 
//		return result;
//	}
//	else
//		return null;
//}	
	
	public int size() {return size;}

	public int capacity() {return elements.length;}

}