// Ausgangsversion im Kapitel "Klassen und Objekte"

public class Bruch {
	private int	zaehler;          // wird automatisch mit 0 initialisiert
	private int	nenner = 1;       // wird manuell mit 1 initialisiert
	private String etikett = "";  // die Ref.typ-Init. auf null wird ersetzt, siehe Text

	public void setzeZaehler(int zpar) {zaehler = zpar;}

	public boolean setzeNenner(int n) {
		if (n != 0)	{
			nenner = n;
			return true;
		} else
			return false;
	}

	public void setzeEtikett(String epar) {
		if (epar.length() <= 40)
			etikett = epar;
		else
			etikett = epar.substring(0, 40);
	}

	public int gibZaehler() {return zaehler;}

	public int gibNenner() {return nenner;}

	public String gibEtikett()	{return etikett;}
	
	public void kuerze() {
		// grten gemeinsamen Teiler mit dem Euklidischen Algorithmus bestimmen
		// (performante Variante mit Modulo-Operator)
		if (zaehler != 0) {
			int rest;
			int ggt = Math.abs(zaehler);
			int divisor = Math.abs(nenner);
			do {
				rest = ggt % divisor;
				ggt = divisor;
				divisor = rest;
			} while (rest > 0);
			zaehler /= ggt;
			nenner  /= ggt;
		} else
			nenner = 1;
	}	

	public void addiere(Bruch b) {
		zaehler = zaehler*b.nenner + b.zaehler*nenner;
		nenner = nenner*b.nenner;
		this.kuerze();
	}
	
	public void frage() {
		int n;
		do {
			System.out.print("Zaehler: ");
			setzeZaehler(Simput.gint());
		} while (Simput.checkError());
		do {
			System.out.print("Nenner : ");
			n = Simput.gint();
			if (n == 0 && !Simput.checkError())
				System.out.println("Der Nenner darf nicht Null werden!\n");
		} while (n == 0);
		setzeNenner(n);
	}

	public void zeige() {
		String luecke = "";
		int el = etikett.length();
		for (int i=1; i<=el; i++)
			luecke = luecke + " ";
		System.out.println(" " + luecke  + "   " + zaehler + "\n" +
		                   " " + etikett + " -----\n" +
		                   " " + luecke  + "   " + nenner + "\n");
	}
}