public class Duration {
	private long hours;
	private int minutes, seconds;

	public Duration(int h, int min, int sec) {
		setDuration(h, min, sec);
	}

	public Duration(long secTotal) {
		setDuration(secTotal);
	}
	
	public Duration() {}

	public boolean setDuration(int h, int min, int sec) {
		if (h >= 0 && (min >= 0 && min < 60) &&	(sec >= 0 && sec < 60)) { 
			hours = h;
			minutes = min;
			seconds = sec;
			return true;
		} else
			return false;
	}

	public boolean setDuration(long secTotal) {
		if (secTotal >= 0) {
			hours = secTotal/3600;
			minutes = (int) (secTotal-hours*3600)/60;
			seconds = (int) (secTotal-hours*3600-minutes*60);
			return true;
		} else
			return false;
	}

	public long getHours() {
		return hours;
	}

	public int getMinutes() {
		return minutes;
	}

	public int getSeconds() {
		return seconds;
	}

	public boolean setHours(long h) {
		if (h >= 0) {
			hours = h;
			return true;
		} else
			return false;
	}

	public boolean setMinutes(int min) {
		if (min >= 0 && min < 60) {
			minutes = min;
			return true;
		} else
			return false;
	}

	public boolean setSeconds(int sec) {
		if (sec >= 0 && sec < 60) {
			seconds = sec;
			return true;
		} else
			return false;
	}
	
	public long toSeconds() {
		return hours * 3600 + minutes * 60 + seconds;
	}

	public String toString(){
		return String.format("%5d:%02d:%02d %s", hours, minutes, seconds, "h:m:s");
	}
}
