// Leistungsvergleich List-Implementierungen

import java.util.*;

class Listen {
	static final int ANZ = 20_000;

	static void testList(List<String> lis_) {
		// Dass eine Referenzvariable mit Schnittstellendatentyp auf ein Objekt
		// aus einer beliebige implementierenden Klasse zeigen kann, ist hier sehr praktisch,
		// so dass der Vorgriff auf das Interface-Kapitel in Kauf genommen wird.
		List<String> liste = lis_;
		StringBuilder sb = new StringBuilder();
		Random ran = new Random();

		// Fllen
		System.out.println("Kollektionsklasse:\t" + liste.getClass());
		long start = System.currentTimeMillis();
		for (int i = 0; i < ANZ; i++) {
			sb.delete(0, 6);
			for (int j = 0; j < 5; j++)
				sb.append((char) (65 + ran.nextInt(26)));
			liste.add(sb.toString());
		}
		System.out.println(" Zeit zum Fuellen:\t" +
				(System.currentTimeMillis()-start));
		
		// Abrufen per Index-Zugriff
		start = System.currentTimeMillis();
		for (int i = 0; i < ANZ; i++)
			liste.get(ran.nextInt(ANZ));
		System.out.println(" Zeit zum Abrufen:\t" +
				(System.currentTimeMillis()-start));

		// Einfgen am Listenanfang
		start = System.currentTimeMillis();
		for (int i = 0; i < ANZ; i++)
			liste.add(0, "neu");
		System.out.println(" Zeit zum Einfuegen:\t" +
				(System.currentTimeMillis()-start));
		
		// Lschen am Listenanfang
		start = System.currentTimeMillis();
		for (int i = 0; i < 2*ANZ; i++)
			liste.remove(0);
		System.out.println(" Zeit zum Loeschen:\t" +
				(System.currentTimeMillis()-start) + "\n");
	}

	public static void main(String[] args) {
		testList(new ArrayList<String>());
		testList(new Vector<String>());
		testList(new LinkedList<String>());
	}
}
