import javax.swing.*;
import java.awt.*;

class AvailableFontFamilies extends JFrame {
	public AvailableFontFamilies() {
		super("Verfgbare Schriftfamilien");
		FontPanel pan = new FontPanel();
		pan.setBackground(Color.WHITE);
		add(new JScrollPane(pan), BorderLayout.CENTER);
		setSize(300, 300);
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setVisible(true);
	}

	private class FontPanel extends JPanel {
		public void paintComponent(Graphics g) {
			super.paintComponent(g);
			GraphicsEnvironment ge = GraphicsEnvironment.getLocalGraphicsEnvironment();
			String[] fontFamilies = ge.getAvailableFontFamilyNames();
			Graphics2D g2 = (Graphics2D) g;
			RenderingHints rh = new RenderingHints(
					RenderingHints.KEY_TEXT_ANTIALIASING,
					RenderingHints.VALUE_TEXT_ANTIALIAS_ON);
			g2.setRenderingHints(rh);
			int i = 0;
			for (String s : fontFamilies) {
				i++;
				Font font = new Font(s, Font.PLAIN, 18);
				g.setFont(font);
				g.drawString(s, 10, i*20);
			}
			setPreferredSize(new Dimension(100, i*20));
		}
	}

	public static void main(String[] args) {
//		new AvailableFontFamilies();
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				new AvailableFontFamilies();
			}
		});
	}
}