import javax.imageio.ImageIO;
import javax.swing.*;
import java.awt.*;
import java.awt.geom.Rectangle2D;
import java.awt.image.*;
import java.io.File;
import java.io.IOException;

class BufferedImageDemo extends JFrame {
	private BufferedImage biLand, biEB;
	
	public BufferedImageDemo() {
		super("BufferedImage - Demo");
		ImagePanel pan = new ImagePanel();
		pan.setPreferredSize(new Dimension(686, 276));
		getContentPane().add(pan, BorderLayout.CENTER);
		
		// Bild aus einer Datei laden.
		try {
			biLand = ImageIO.read(new File("land.jpg"));
			biEB = ImageIO.read(new File("EmmaBodo.jpg"));
		} catch (IOException e) {}

		Graphics2D g2 = (Graphics2D) biEB.getGraphics();
		g2.setPaint(Color.RED);
		g2.setStroke(new BasicStroke(5));
		g2.draw(new Rectangle2D.Double(1440, 276, 400, 350));

		try {
			ImageIO.write(biEB, "jpg", new File("EmmaBodoMod.jpg"));
		} catch (IOException e) {}
		
		pack();
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setVisible(true);
	}

	// Originale und horizontal gedehnte Darstellung
	private class ImagePanel extends JPanel {
		public void paintComponent(Graphics g) {
			super.paintComponent(g);
			g.drawImage(biLand, 10, 10, null);
			g.drawImage(biLand, 276, 10, 676, 266, 0, 0, 256, 256, null);
		}
	}

//	// Ein Filter aus dem Java - Tutorial
//	private class ImagePanel extends JPanel {
//		public void paintComponent(Graphics g) {
//			super.paintComponent(g);
//			Graphics2D g2 = (Graphics2D) g; 
//		    byte lut[] = new byte[256];
//		    for (int j=0; j<196; j++) {
//		        lut[j] = (byte)(256-j); 
//		    }
//		    ByteLookupTable blut = new ByteLookupTable(0, lut); 
//		    LookupOp lop = new LookupOp(blut, null);
//		    g2.drawImage(biLand, lop, 10, 10);
//		}
//	}

//	// Verndertes BufferedImage-Objekt
//	private class ImagePanel extends JPanel {
//		public void paintComponent(Graphics g) {
//			super.paintComponent(g);
//			g.drawImage(biEB, 10, 10, 610, 410, 0, 0, 2166, 1141, null);
//		}
//	}
	
	public static void main(String[] args) {
		new BufferedImageDemo();
	}
}