import javax.imageio.ImageIO;
import javax.swing.*;
import java.awt.*;
import java.awt.geom.*;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;

class PaintAndStroke extends JFrame {
	public PaintAndStroke() {
		super("Java2D");
		MyPanel pan = new MyPanel();
		getContentPane().add(pan, BorderLayout.CENTER);
		setSize(250, 350);
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setVisible(true);
	}

	public static void main(String[] args) {
		new PaintAndStroke();
	}

	class MyPanel extends JPanel {
		public void paintComponent(Graphics g) {
			super.paintComponent(g);

			Graphics2D g2 = (Graphics2D) g; 
			g2.setPaint(new GradientPaint(0, 0, Color.RED, 100, 50,Color.ORANGE, true));
			Ellipse2D.Double ellip = new Ellipse2D.Double(20, 20, 200, 160);
			g2.fill(ellip);
			g2.setColor(Color.BLACK);
			g2.draw(ellip);

			g2.setPaint(Color.ORANGE);
			float[] dash = {30, 10, 15, 10};
			g2.setStroke(new BasicStroke(5, BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND, 1, dash, 40));
			g2.draw(new Rectangle2D.Double(20, 200, 200, 100));

			
//			// GradienPaint-Demo
//			g2.setPaint(new GradientPaint(20, 500, Color.WHITE, 220, 500, Color.BLUE, false));
//			g2.fill(new Rectangle2D.Double(20, 400, 400, 200));

//			// TexturePaint-Demo, Importieren einer Bitmap-Datei
//			BufferedImage bi = null;
//			try {
//				bi = ImageIO.read(new File("Kreis.png"));
//			} catch (IOException e) {}
//			g2.setPaint(new TexturePaint(bi, new Rectangle2D.Double(0,0,20,20)));
//			g2.fill(new Rectangle2D.Double(20, 400, 400, 200));

//			// TexturePaint-Demo, BufferedImage als Ausgabeziel fr Graphics2D-Methoden
//			BufferedImage bi = new BufferedImage(25, 25, BufferedImage.TYPE_INT_RGB);
//			Graphics2D big2 = bi.createGraphics();
//			big2.setColor(new Color(153, 217, 234));
//			big2.fill(new Rectangle2D.Double(0, 0, 25, 25));
//			big2.setColor(new Color(255, 174, 201));
//			big2.fill(new Ellipse2D.Double(5, 5, 14, 14));
//			g2.setPaint(new TexturePaint(bi, new Rectangle2D.Double(0, 0, 25, 25)));
//			g2.fill(new Ellipse2D.Double(20, 400, 400, 200));
	
//			// CAP-Demo
//			g2.setStroke(new BasicStroke(20, BasicStroke.CAP_BUTT, BasicStroke.JOIN_ROUND));
//			g2.draw(new Line2D.Double(20, 400, 50, 400));
//
//			g2.setStroke(new BasicStroke(0, BasicStroke.CAP_BUTT, BasicStroke.JOIN_ROUND));
//			g.setColor(Color.BLACK); g.drawLine(20, 400, 50, 400); g.setColor(Color.ORANGE);
//
//			g2.setStroke(new BasicStroke(20, BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND));
//			g2.draw(new Line2D.Double(20, 430, 50, 430));
//
//			g2.setStroke(new BasicStroke(0, BasicStroke.CAP_BUTT, BasicStroke.JOIN_ROUND));
//			g.setColor(Color.BLACK); g.drawLine(20, 430, 50, 430); g.setColor(Color.ORANGE);
//			
//			g2.setStroke(new BasicStroke(20, BasicStroke.CAP_SQUARE, BasicStroke.JOIN_ROUND));
//			g2.draw(new Line2D.Double(20, 460, 50, 460));
//
//			g2.setStroke(new BasicStroke(0, BasicStroke.CAP_BUTT, BasicStroke.JOIN_ROUND));
//			g.setColor(Color.BLACK); g.drawLine(20, 460, 50, 460); g.setColor(Color.ORANGE);

//			// JOIN-Demo
//			Path2D.Double ecke = new Path2D.Double();
//			ecke.moveTo(20, 400);
//			ecke.lineTo(70, 350); ecke.lineTo(120, 400);
//			g2.setStroke(new BasicStroke(20, BasicStroke.CAP_BUTT, BasicStroke.JOIN_BEVEL));
//			g2.draw(ecke);
//
//			ecke = new Path2D.Double();
//			ecke.moveTo(220, 400);
//			ecke.lineTo(270, 350); ecke.lineTo(320, 400);
//			g2.setStroke(new BasicStroke(20, BasicStroke.CAP_BUTT, BasicStroke.JOIN_MITER));
//			g2.draw(ecke);
//
//			ecke = new Path2D.Double();
//			ecke.moveTo(420, 400);
//			ecke.lineTo(470, 350); ecke.lineTo(520, 400);
//			g2.setStroke(new BasicStroke(20, BasicStroke.CAP_BUTT, BasicStroke.JOIN_ROUND));
//			g2.draw(ecke);

//			// translate()-Demo
//			Ellipse2D.Double pr = new Ellipse2D.Double(0, 0, 150, 70);
//			for (int i = 0; i < 5; i++) {
//				g2.fill(pr);
//				g2.translate(50, 50);
//			}
		
		}
	}
}