import javax.swing.*;
import java.awt.*;
import java.awt.geom.*;

class Path2Stern extends JFrame {
	public Path2Stern() {
		super("Path2DStern");
		MyPanel pan = new MyPanel();
		getContentPane().add(pan, BorderLayout.CENTER);
		setSize(400, 400);
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setVisible(true);
	}

	public static void main(String[] args) {
		new Path2Stern();
	}

	class MyPanel extends JPanel {
		public void paintComponent(Graphics g) {
			super.paintComponent(g);
			Graphics2D g2 = (Graphics2D) g;
			g2.setColor(Color.yellow);
			
			// Endpunkte der Zacken berechnen
			int anzacken = 5;
			int[] xvek = new int[anzacken];
			int[] yvek = new int[anzacken];
			int shift = 180, len = 150;			
			double winkel = Math.PI / 2;
			for (int i = 0; i < anzacken; i++) {
				double kosinus = Math.cos(winkel);
				double sinus = Math.sin(winkel);
				int x = (int) (shift + kosinus * len);
				int y = (int) (shift + sinus * len);
				xvek[i] = x;
				yvek[i] = y;
				winkel += 4 * Math.PI / anzacken;
			}
		
			Path2D.Double stern = new Path2D.Double();
			//Path2D.Double stern = new Path2D.Double(Path2D.WIND_EVEN_ODD);
			stern.moveTo(xvek[0], yvek[0]);
			for (int i = 1; i < anzacken; i++)
				stern.lineTo(xvek[i], yvek[i]);
			stern.closePath();	
			g2.fill(stern);
			g2.setColor(Color.black);
			for (int i = 0; i < anzacken; i++)
				g2.drawString(String.valueOf(i), xvek[i], yvek[i]);
			
		}
	}
}