import javax.swing.*;
import java.awt.*;
import java.awt.geom.AffineTransform;

class ResolutionIndependence extends JFrame {
	public ResolutionIndependence() {
		super("Auflsungsunabhngigkeit");
		GraphicsPanel pan = new GraphicsPanel();
		getContentPane().add(pan, BorderLayout.CENTER);
		setSize(270, 455);
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setVisible(true);
	}

	public static void main(String[] args) {
		new ResolutionIndependence();
	}

	class GraphicsPanel extends JPanel {
		public void paintComponent(Graphics g) {
			super.paintComponent(g);
			g.setColor(Color.DARK_GRAY);
			int dpi = Toolkit.getDefaultToolkit().getScreenResolution();
			g.drawString("User Space = Device Space", 10, 20);
			g.fillRect(10, 30, 72, 72);
			Graphics2D g2 = (Graphics2D) g;

			RenderingHints rh = new RenderingHints(
					RenderingHints.KEY_TEXT_ANTIALIASING,
					RenderingHints.VALUE_TEXT_ANTIALIAS_ON);
			g2.setRenderingHints(rh);
			
			//g2.drawString(String.valueOf(dpi), 100, 20);
			//AffineTransform at = new AffineTransform();
			//at.setToScale(dpi/72.0 , dpi/72.0);
			//g2.setTransform(at);

			g2.scale(84/72.0 , 84/72.0);
			g.drawString("Nach Skalierung mit 84/72", 10, 110);
			g2.fillRect(10, 120, 72, 72);

			g2.scale(dpi/72.0 , dpi/72.0);
			g.drawString("Nach Skalierung mit 96/72", 10, 170);
			g2.fillRect(10, 180, 72, 72);
		}
	}
}