import java.applet.*;
import java.awt.*;
import java.awt.event.*;

import javax.swing.*;

public class HiMusik extends JApplet implements ActionListener, ItemListener {
	boolean man = false;

	private final String LABELPREFIX = "Anzahl der Klicks: ";
	private JLabel lblCount;
	private int numClicks;
	private JButton cbCount;
	private JButton cbReset;	
	private JPanel panCount;
	private JPanel panReset;	
	private JCheckBox cbMusic;
	private AudioClip clip;

	public void init() {
		cbCount = new JButton("Klick");
		cbReset = new JButton("Reset");

		panCount = new JPanel();
		panCount.add(cbCount);
		panCount.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
		panCount.setLayout(new BoxLayout(panCount, BoxLayout.X_AXIS));
		this.getRootPane().setDefaultButton(cbCount);

		panReset = new JPanel();
		panReset.add(cbReset);
		panReset.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
		panReset.setLayout(new BoxLayout(panReset, BoxLayout.X_AXIS));
		
		lblCount = new JLabel(LABELPREFIX + "0");
		lblCount.setFont(new Font(Font.SANS_SERIF, Font.BOLD, 16));

		cbMusic = new JCheckBox("Musik ein/aus", true);
		cbMusic.setSelected(false);
		
		setLayout(new GridLayout(2, 2, 10, 10));
	
		// Diese add()-Aufrufe befrdern Komponenten auf die ContentPane der JApplet-Komponente.
		// add(panCount) ist also quivalent zu getContentPane().add(panCount) 
		add(panCount);
		add(lblCount);
		add(panReset);
		add(cbMusic);

		cbCount.addActionListener(this);
		cbReset.addActionListener(this);
		cbMusic.addItemListener(this);

		clip = getAudioClip(getCodeBase(),"trippygaia1.mid");
	}

	public void actionPerformed(ActionEvent e) {
		if (e.getSource() == cbCount) {
			numClicks++;
			lblCount.setText(LABELPREFIX + numClicks);
		} else {
			numClicks = 0;
			lblCount.setText(LABELPREFIX + "0");
		}
	}

	public void itemStateChanged(ItemEvent e) {
		man = !man;
		if (man)
			clip.loop();
		else
			clip.stop();
	}

	public void destroy () {
		clip.stop();
	}
}
