import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import javax.swing.*;

public class MusicBox extends JApplet implements ActionListener {
	private JButton cbStart = new JButton("Start");
	private JButton cdChange = new JButton("Wechseln");
	private JButton cbStop = new JButton("Stopp");
	private JLabel label = new JLabel("");
	private final static int MAXCLIP = 5;
	private int actclip = 0;
	private boolean musicOn;
	private AudioClip[] clips = new AudioClip[MAXCLIP];
	private String[] titles = new String[MAXCLIP];

	public void init() {
		cbStart.addActionListener(this);
		cdChange.addActionListener(this);
		cbStop.addActionListener(this);

		add(cbStart, BorderLayout.WEST);
		add(cdChange, BorderLayout.CENTER);
		add(cbStop, BorderLayout.EAST);
		add(label, BorderLayout.SOUTH);

		java.net.URL cb = getCodeBase();
		clips[0] = getAudioClip(cb,"chirp1.au");
		titles[0] = "Vogel-Geschwister (.au)";
		clips[1] = getAudioClip(cb,"elise.mid");
		titles[1] = "Fr Elise (mid)";
		clips[2] = getAudioClip(cb,"trippygaia1.mid");
		titles[2] = "Trippygaia (mid)";
		clips[3] = getAudioClip(cb,"BoogieWoogie.mid");
		titles[3] = "Boogie Woogie Blues (mid)";
		clips[4] = getAudioClip(cb,"spacemusic.au");
		titles[4] = "Spacemusic (au)";
		label.setText(titles[0]);
	}

	public void stop() {
		clips[actclip].stop();
	}

	public void start() {
		if (musicOn)
			clips[actclip].loop();
	}

	public void destroy () {
		clips[actclip].stop();
	}
	
	public void actionPerformed(ActionEvent e) {
		clips[actclip].stop();
		if (e.getSource() == cbStop)
			musicOn = false;
		else {
			if (e.getSource() == cdChange) {
				if (actclip < MAXCLIP-1)
			    	actclip++;
			    else
			    	actclip = 0;
				label.setText(titles[actclip]);
		 	} else	// Source == start
				musicOn = true;
	 		if (musicOn)
	 			clips[actclip].loop();
		}
	}
}