import java.text.DateFormat;
import java.util.Date;
import java.util.concurrent.*;

class RandomNumberCruncher implements Callable<Double> {
	public Double call() throws TimeoutException {
		final int anz = 100_000_000;
		double d = 0.0;
		long start = System.currentTimeMillis();
		for (int i = 0; i < anz; i++) {
			d += Math.random();
			if (System.currentTimeMillis() - start > 5000)
				throw new TimeoutException();
		}
		return new Double(d/anz);
	}
}

class CallableDemo {
	public static void main(String[] args) {
		DateFormat df = DateFormat.getDateTimeInstance();
		ExecutorService es = Executors.newSingleThreadExecutor();
		Future<Double> fd = es.submit(new RandomNumberCruncher());
		while (!fd.isDone()) {
			System.out.println("Warten auf call()-Ende ("+df.format(new Date())+")");
			try {
				Thread.sleep(1000);
			} catch (Exception e) {}
		}
		try {
			System.out.println("\nMittelwert der Zufallszahlen: "+fd.get());
		} catch (Exception e) {
			System.out.println("\nException beim get()-Aufruf:\n  "+e);
		}
		es.shutdown();
	}
}