import java.util.concurrent.ForkJoinPool;

class ForkJoinTest {
	public static void main(String[] args) {
		int kerne = Runtime.getRuntime().availableProcessors();
		System.out.println("Kerne: "+kerne);
		int anzahl = 50_000_000;
		int schwelle = 50_000;
		long start;
		int ergebnis; 
		
		// Testdaten erstellen
		double[] daten = new double[anzahl];
		for (int i = 0; i < anzahl; i++) {
			daten[i] = Math.random()*Math.PI;
		}
		
		// Beide Verfahren wg. variabler Messungen mehrfach anwenden 
		for (int i = 0; i < 5; i++) {
			
			// Single-Thread-Lsung
			start = System.currentTimeMillis();
			ergebnis = MaxFinder.findeMax(daten, anzahl);
			System.out.println("Laufzeit ohne FJF:\t\t\t "+(System.currentTimeMillis()-start)+" Millisekunden (Max.: "+ergebnis+")");
			
			// Fork-Join - Lsung
			start = System.currentTimeMillis();
			ergebnis = MaxFinder.findeMax(daten, schwelle);
			System.out.println("Laufzeit mit FJF bei Schwelle "+schwelle+":\t "+(System.currentTimeMillis()-start)+" Millisekunden (Max.: "+ergebnis+")\n");
			
		}
	}
}
