import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class LaufschriftEinAus extends JApplet implements Runnable, ItemListener {
	private final String TXT = "Wo laufen sie denn?  Wo laufen sie denn hin?";
	private final int pause  = 20;
	private final int sprung = 1;
	private GraphicsPanel gp;
	private int x, tb;	// akt. Schreibpos, Textbreite
	private final String LABELPREFIX = "  Anzahl der Klicks: ";
	private JLabel lblKlicks;
	private int anzKlicks = 0;
	private boolean lbAnAus = true;
	private Thread threadLb;
	private JCheckBox chkLaufband;
	private JButton cbLbBeenden;

	public void init() {
		lblKlicks = new JLabel(LABELPREFIX + "0    ");
		JButton cbClick = new JButton("Klicker");
		cbClick.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				anzKlicks++;
				lblKlicks.setText(LABELPREFIX + anzKlicks);
			}
		});

		chkLaufband = new JCheckBox("Laufband unterbrechen/fortsetzen", true);
		chkLaufband.addItemListener(this);

		cbLbBeenden = new JButton("Laufband beenden");
		cbLbBeenden.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				chkLaufband.setEnabled(false);
				cbLbBeenden.setEnabled(false);
				threadLb.interrupt();
			}
		});
		
		JPanel panCenter = new JPanel();
		panCenter.setLayout(new GridLayout(2, 1, 20, 20));
		JPanel panCenterOben = new JPanel();
		panCenterOben.add(cbClick); panCenterOben.add(lblKlicks);
		JPanel panCenterUnten = new JPanel();
		panCenterUnten.add(chkLaufband); panCenterUnten.add(cbLbBeenden);

		panCenter.add(panCenterOben);
		panCenter.add(panCenterUnten);
		add(panCenter, BorderLayout.CENTER);
		
		gp = new GraphicsPanel();
		gp.setBackground(Color.YELLOW);
		gp.setFont(new Font("SansSerif", Font.ITALIC, 16));
		tb = getFontMetrics(gp.getFont()).stringWidth(TXT);
		gp.setPreferredSize(new Dimension(0, 20)); // Hhe fr das Band mit der Laufschrift
		add(gp, BorderLayout.SOUTH);

		threadLb = new Thread(this);
		threadLb.start();
	}

	public void run() {
		while (true) {
			if (Thread.currentThread().isInterrupted()) {
				lbAnAus = false;
				gp.repaint();
				return;
			}
			try {
				Thread.sleep(pause);
				if (!lbAnAus)
					synchronized(this) {wait();}
			} catch(InterruptedException ie) {Thread.currentThread().interrupt();}
			if (x-sprung + tb < 0)
				x = getSize().width;
			else
				x -= sprung;
			gp.repaint();
		}
	}

	public synchronized void itemStateChanged(ItemEvent e) {
		lbAnAus = !lbAnAus;
		if (lbAnAus)
			synchronized(this) {notify();}			
		else
			repaint();
	}
	
	private class GraphicsPanel extends JPanel {
		public void paintComponent(Graphics g){
			super.paintComponent(g);
			if (lbAnAus)
				g.drawString(TXT, x, 18);
			else {
				Rectangle r = g.getClipBounds();
				g.clearRect(0, 0, r.width, r.height);
			}
		}
	}
}
