import java.io.*;
import java.net.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class ChatClient extends JFrame {
	static private String host;
	static final private int PORT = 9999;
	private JTextField eingabe;
	private JTextArea protokoll;
	private BufferedReader br;
	private PrintWriter pw;
	private String zeile;
	private boolean connected = false;
   
	public ChatClient() {
		try {
			setTitle("ChatClient (Name: "+InetAddress.getLocalHost().getHostName()+", verbunden mit: "+host+")");
		} catch (Exception e) {
			setTitle("ChatClient (verbunden mit: "+host+")");
		}
		JPanel panel = new JPanel(new BorderLayout());
		JLabel label = new JLabel("Eingabe: ");
		eingabe = new JTextField();
		eingabe.addActionListener(
			new ActionListener() {
				public void actionPerformed(ActionEvent event ) {
				   senden(eingabe.getText());
				   eingabe.setText("");
					}
				}
			);
		panel.add(label, BorderLayout.WEST);
		panel.add(eingabe, BorderLayout.CENTER);
		getContentPane().add(panel, BorderLayout.SOUTH);
		
		protokoll = new JTextArea();
		protokoll.setEditable(false);
		protokoll.setFocusable(false);
		getContentPane().add(new JScrollPane(protokoll), BorderLayout.CENTER);
		setSize(500, 200);
		setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
		addWindowListener(new Ex());
		
		setVisible(true);
		connectAndListen();
	}

	private void connectAndListen() {
		try {
			Socket server = new Socket(host, PORT);
			br = new BufferedReader(new InputStreamReader(server.getInputStream()));
			pw = new PrintWriter(server.getOutputStream(), true);
			connected = true;
		} catch (Exception e) {
			JOptionPane.showMessageDialog(null, "Fehler bei der Verbindungsaufnahme", "ChatClient", JOptionPane.ERROR_MESSAGE);
			System.exit(1);
		}

		Runnable r = new Runnable() {
			public void run() {
				try {
					while ((zeile = br.readLine()) != null) {
						protokoll.append(zeile+"\n");
						protokoll.setCaretPosition(protokoll.getText().length()-1); // Vertikales Rollen erzwingen
						if (zeile.equals("Tsch")) {
							try {Thread.sleep(1000);
							} catch (Exception e) {}
							System.exit(0);
						}
					}
				} catch (IOException e) {
						JOptionPane.showMessageDialog(null, "Kontakt mit dem Server verloren", "ChatClient", JOptionPane.ERROR_MESSAGE);
							System.exit(1);
					}
				}
		      };
		(new Thread(r)).start();
	}
	
	private void senden(String s) {
		if (connected)
			pw.println(s);
	}
   
	private class Ex extends WindowAdapter {
		public void windowClosing(WindowEvent e) {
			senden("quit");
			System.exit(0);
		}
	}

	public static void main(String[] args) {
		if (args.length == 0) {
			JOptionPane.showMessageDialog(null, "Kein Server angegeben", "ChatClient",
				JOptionPane.ERROR_MESSAGE);
			System.exit(1);
		} else
			host = args[0];
		
		javax.swing.SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				new ChatClient();
			}
		});
	}
}
