import java.net.*;
import java.util.*;
import java.text.*;
import java.util.concurrent.*;

public class ChatServer {
	private final static int port = 9999;
	private static int nummer;
	private static DateFormat df = DateFormat.getDateTimeInstance();
	private static ArrayList<ClientThread> lot = new ArrayList<ClientThread>(); 
	private static ClientThread ct = null;

	public static void main(String[] args) {
		try {
			ExecutorService es = Executors.newCachedThreadPool();
			ServerSocket server = new ServerSocket(port);
			System.out.println("ChatServer gestartet ("+df.format(new Date())+")");
			while(true) {
				Socket client = server.accept();
				nummer++;
				ct = new ClientThread(client, nummer);
				lot.add(ct);
				prot("Verbindung Nummer "+nummer+" gestartet" +
						"\n  Rechner: "+client.getInetAddress().getHostName() +
						" IP: "+ client.getInetAddress().getHostAddress() +
						" Port: "+client.getPort() +
						"\n  Anzahl der aktiven Verbindungen: "+lot.size());
				es.execute(ct);
			}
		} catch (Exception e) {
			prot("Fehler: \n  "+e.toString());
		}
	}

	public static synchronized void tellAll(String s) {
		for (ClientThread ct : lot)
			ct.tellClient(s);
	}
	
	public static synchronized void decr(ClientThread ct, int nummer, String name) {
		lot.remove(ct);
		System.out.println("\n"+df.format(new Date())+ " Verbindung Nummer "+nummer+" beendet"+
				"\n  Rechner: "+name+"\n  Anzahl der aktiven Verbindungen: "+lot.size());
	}

	public static synchronized void prot(String s) {
		System.out.println("\n"+df.format(new Date())+" "+s);
	}	

	public static synchronized int getNConnects() {
		return lot.size();
	}	
}