import java.io.*;
import java.net.*;

import javax.swing.JOptionPane;

public class ClientThread extends Thread {
	private Socket client;
	private String name;
	private int nummer;
	private PrintWriter pw;
	
	public ClientThread(Socket cl, int nr) {
		client = cl;
		nummer = nr;
		name = cl.getInetAddress().getHostName();
		// Die folgenden Zeilen setzen einen sinnvollen Host-Namen voraus:
		int pos = name.indexOf(".");
		if (pos > 0)
			name = name.substring(0, pos);
	}

	public void run() {
		String zeile;
		try {
			BufferedReader br = new BufferedReader(new InputStreamReader(client.getInputStream()));
			pw = new PrintWriter(client.getOutputStream(), true);
			pw.println("Willkommen, "+name+"! - Aktive Teilnehmer: "+ChatServer.getNConnects()+" - Beenden mit 'quit'");
			while ((zeile = br.readLine()) != null) {
				if (zeile.trim().equals("quit")) {
					pw.println("Tsch");
					break;
				}
				ChatServer.tellAll(name+": "+zeile);
			}
		} catch (Exception e) {
			ChatServer.prot("Fehler bei Verbindung Nummer "+nummer+" mit "+name+"\n"+e.toString());
		} finally {
			ChatServer.decr(this, nummer, name);
			try {client.close();} catch (Exception ignored) {}			
		}
	}
	
	public void tellClient(String s) {
		pw.println(s);
	}
}