import java.net.*;
import java.util.StringTokenizer;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

class DNS extends JFrame implements ActionListener {
	private Container cont = getContentPane();
	private JPanel panIP = new JPanel();
	private JButton cbGetIP = new JButton("IPv4-Adresse ermitteln");
	private JButton cbGetName = new JButton("Host-Namen ermitteln");
	private JTextField tfHostName = new JTextField(50);
	private JLabel lblHostName = new JLabel("Host-Name:");
	private JTextField tfIP = new JTextField(50);	
	private JLabel lblIP = new JLabel("IPv4-Adresse:");
	
	DNS() {
		super("IPv4-Adresse oder Host-Namen bestimmen");
		panIP.setLayout(new GridLayout(2, 3, 10, 10));
		panIP.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));

		cbGetIP.addActionListener(this);
        cbGetName.addActionListener(this);

		panIP.add(lblHostName);	panIP.add(tfHostName); panIP.add(cbGetIP);
		panIP.add(lblIP); panIP.add(tfIP); panIP.add(cbGetName);

		cont.add(panIP, BorderLayout.CENTER);
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setMinimumSize(new Dimension(550, 120));
	}

	public void actionPerformed(ActionEvent ae) {
		try {
			if (ae.getSource() == cbGetIP) {
				InetAddress ia = InetAddress.getByName(tfHostName.getText());
				tfIP.setText(ia.getHostAddress());
			} else {
				byte[] ipAddr = new byte[4];
				StringTokenizer st = new StringTokenizer(tfIP.getText(), ".", false);
				for (int i = 0; i < 4; i++)
					ipAddr[i] = (byte) Integer.parseInt(st.nextToken());
				InetAddress ia = InetAddress.getByAddress(ipAddr);
				tfHostName.setText(ia.getHostName());
			}
		} catch(Exception e) {
			JOptionPane.showMessageDialog(null, e,
					"Exception", JOptionPane.INFORMATION_MESSAGE);
		}
	}

	public static void main(String args[]) {
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				DNS dns = new DNS();
				dns.setVisible(true);
			}
		});
	}
}
