import java.net.*;
import java.io.*;
import java.text.*;
import java.util.*;

class URLConnectionDemo {
	public static void main(String[] args) {
		BufferedReader br = null;
		try {
			String urlString;
			if (args.length == 0)
				urlString = "http://www.spiegel.de/";
				//urlString = "http://docs.oracle.com/javase/7/docs/api/java/net/URLConnection.html";
			else
				urlString = args[0];

			// URLConnection-Objekt generieren
			URL url = new URL(urlString);
			URLConnection urlConn = url.openConnection();
			
			// Request-Header setzen
			// urlConn.setRequestProperty("If-Modified-Since", "Mon, 11 Feb 2008 00:00:00 GMT");
			DateFormat df = DateFormat.getDateTimeInstance();
			urlConn.setIfModifiedSince(df.parse("01.01.2012 00:00:00").getTime());
			
			// Verbindung herstellen und Response-Header entgegennehmen
			urlConn.connect();

			// Response-Header auswerten
			System.out.println("\nResponse-Header:");
			System.out.println("  Content-Type:\t\t"+urlConn.getContentType());
			System.out.println("  Content-Length:\t"+urlConn.getContentLength());
			System.out.println("  Expiration:\t\t"+df.format(new Date(urlConn.getExpiration())));
			System.out.println("  Last Modified:\t"+df.format(new Date(urlConn.getLastModified()))); 

			// Inhalt ausgeben
			System.out.println("\nWeiter zum Inhalt mit Enter");
			System.in.read();
			br = new BufferedReader(new InputStreamReader(urlConn.getInputStream()));
			String zeile;
			while ((zeile = br.readLine()) != null)
				System.out.println(zeile);
		} catch (MalformedURLException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} catch (ParseException e) {
			e.printStackTrace();
		} finally { 
			if (br != null)
				try {br.close();} catch (IOException e) {}

		}
	}
}
