import java.net.*;
import java.util.*;
import java.util.concurrent.*;
import java.text.*;

class EchoServer {
	private static int nconn, nummer;
	private static DateFormat df = DateFormat.getDateTimeInstance();
	
	public static void main(String[] args) {
		try {
			ExecutorService es = Executors.newCachedThreadPool();
			ServerSocket echoServer = new ServerSocket(9999);
			System.out.println("Echoserver gestartet ("+df.format(new Date())+")");
			while(true) {
				Socket client = echoServer.accept();
				incr();
				nummer++;
				prot("Verbindung Nummer "+nummer+":\n  IP-Nummer: "
					+ client.getInetAddress().getHostAddress()
					+ " (Port: "+client.getPort()+")");
				es.execute(new EchoServerThread(client, nummer));
			}
		} catch (Exception e) {
			prot("Fehler: \n  "+e.toString());
		}
	}

	static synchronized void incr() {nconn++;}

	static synchronized void decr(int nummer) {
		nconn--;
		System.out.println("\n"+df.format(new Date())+ " Verbindung Nummer "+nummer+" beendet");
	}

	static synchronized int getNConnects() {return nconn;}
	
	static void prot(String s) {
		System.out.println("\n"+df.format(new Date())+" "+s);
	}
}


