import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

class EventID extends JFrame {
	private JButton cbSchalter;
	private JLabel lblIcon;
	private JLabel lblEvent;

    EventID() {
        super("Ereignis-Kennungen");
        cbSchalter = new JButton("Knopf");
        getContentPane().add(cbSchalter, BorderLayout.WEST);

		lblIcon = new JLabel(new ImageIcon("duke.gif"));
        getContentPane().add(lblIcon, BorderLayout.CENTER);

        lblEvent = new JLabel();
        getContentPane().add(lblEvent, BorderLayout.SOUTH);
        lblEvent.setHorizontalAlignment(JTextField.CENTER);

        cbSchalter.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
            	lblEvent.setText("Schalter gedrckt: "+String.valueOf(e.getID()));
            }
        });
        lblIcon.addMouseListener(new MausLi());
		cbSchalter.addKeyListener(new KeyLi());
		
		addWindowListener(new WinLi());
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setSize(500, 200);
        setVisible(true);
    }

    public static void main(String[] args) {
        new EventID();
    }

	private class MausLi extends MouseAdapter {
		public void mousePressed(MouseEvent e) {
			lblEvent.setText("Maustaste "+String.valueOf(e.getButton())+" gedrckt: "+String.valueOf(e.getID()));
		}
		public void mouseReleased(MouseEvent e) {
			lblEvent.setText("Maustaste "+String.valueOf(e.getButton())+" losgelassen: "+String.valueOf(e.getID()));
		}
	}

	private class KeyLi extends KeyAdapter {
           public void keyPressed(KeyEvent e) {
              lblEvent.setText("Taste gedrckt: "+String.valueOf(e.getID()));
           }
           public void keyReleased(KeyEvent e) {
              lblEvent.setText("Taste losgelassen: "+String.valueOf(e.getID()));
           }
	}

	private class WinLi extends WindowAdapter {
		public void windowActivated(WindowEvent e) {
			lblEvent.setText("Fenster aktiviert: "+String.valueOf(e.getID()));
		}
		public void windowClosing(WindowEvent e) {
            JOptionPane.showMessageDialog(null, "Das Rahmenfenster wird geschlossen");
		}
	}
}
