import java.awt.*;

import javax.swing.*;
import javax.swing.event.*;

class JListDemo extends JFrame {
	
	private final static String titel = "JList-Demo";
	private JPanel panListeLinks, panListeRechts;
	private DefaultListModel<String> modelLinks, modelRechts;
	private JList<String> listLinks, listRechts;	
//	private JList<String> listFest = new JList<>(new String[]{"Eimer","Wand","Brille"});
	
	JListDemo() {
		super(titel);
		Container cont = getContentPane();
		
		modelLinks = new DefaultListModel<String>();
		modelLinks.addElement("Emma"); modelLinks.addElement("Wolle");
		modelLinks.addElement("Brina"); modelLinks.addElement("Diego");
		listLinks = new JList<String>(modelLinks);
		listLinks.setBackground(this.getBackground());
		listLinks.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		panListeLinks = new JPanel();
		panListeLinks.setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));
		panListeLinks.add(listLinks);
		cont.add(panListeLinks, BorderLayout.WEST);

		modelRechts = new DefaultListModel<String>();
		listRechts = new JList<String>(modelRechts);
		listRechts.setBackground(this.getBackground());
		listRechts.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		panListeRechts = new JPanel();
		panListeRechts.setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));
		panListeRechts.add(listRechts);
		cont.add(panListeRechts, BorderLayout.EAST);
		
		ListSelectionHandler lsh = new ListSelectionHandler();
		listLinks.addListSelectionListener(lsh);
		listRechts.addListSelectionListener(lsh);
		
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setSize(210, 130);
		setVisible(true);
	}
	
	public static void main(String[] args) {
		new JListDemo();
	}

	private class ListSelectionHandler implements ListSelectionListener {
		public void valueChanged(ListSelectionEvent e) {
			if (e.getValueIsAdjusting() == true)
				return;
			if (((JList<String>)e.getSource()).getSelectedIndex() < 0)
				return;
			String wahl = ((JList<String>)e.getSource()).getSelectedValue();
			if (e.getSource() == listLinks) {
				modelLinks.removeElement(wahl);
				modelRechts.addElement(wahl);
			} else {
				modelRechts.removeElement(wahl);
				modelLinks.addElement(wahl);
			}
		}
	}
}