import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

class KeyEventDemo extends JFrame {
	private JLabel keyCode, uChar;
	
	KeyEventDemo() {
		super("KeyEvent-Demo");
		
		keyCode = new JLabel(" Key Code:");
		uChar = new JLabel(" Unicode-Zeichen:");
		getContentPane().add(keyCode, BorderLayout.NORTH);
		getContentPane().add(uChar, BorderLayout.SOUTH);
		
		addKeyListener(new KeyAdapter() {
			public void keyPressed(KeyEvent e) {
				keyCode.setText(" Key Code:                "+e.getKeyCode());
			}
			public void keyTyped(KeyEvent e) {
				uChar.setText(" Unicode-Zeichen:  '"+e.getKeyChar()+"'");
			}
			public void keyReleased(KeyEvent e) {
				keyCode.setText(" Key Code:");
				uChar.setText(" Unicode-Zeichen:");
				//uChar.setText(String.valueOf(e.getID() == KeyEvent.KEY_TYPED));
			}
		});
		
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setSize(200, 70);
		setVisible(true);
	}
	
	public static void main(String[] args) {
		new KeyEventDemo();
	}
}