import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

class BorderLayoutDemo extends JFrame implements ActionListener {
	private JButton[] butt;
	private String[] names = {"Norden verstecken", "Sden verstecken", "Osten verstecken",
							  "Westen verstecken", "Zentrum verstecken"};
	private BorderLayout layout = new BorderLayout(5,5);
	
	BorderLayoutDemo() {
		super("BorderLayoutDemo");

		Container cont = getContentPane();
		cont.setLayout(new BorderLayout(5,5));
		
		butt = new JButton[names.length];
		
		for (int i = 0; i < names.length; i++) {
			butt[i] = new JButton(names[i]);
			butt[i].addActionListener(this);
		}

		cont.add(butt[0], BorderLayout.NORTH);
		cont.add(butt[1], BorderLayout.SOUTH);
		cont.add(butt[2], BorderLayout.EAST);
		cont.add(butt[3], BorderLayout.WEST);
		cont.add(butt[4], BorderLayout.CENTER);

		addWindowListener(new
			WindowAdapter() {
				public void windowClosing(WindowEvent e) {
					System.exit(0);
				}
			});

		setSize(500, 200);
		setVisible(true);
	}

	public void actionPerformed(ActionEvent e) {
		for (int i = 0; i < butt.length; i++)
			if (e.getSource() == butt[i])
				butt[i].setVisible(false);
			else
				butt[i].setVisible(true);
		layout.layoutContainer(getContentPane());
	}

	public static void main(String[] arg) {
		new BorderLayoutDemo();
	}
}