import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

class MPCPro extends JFrame {
	private final static String labelPrefix = "Zhlerstand: ";
	private final static String titel = "Multi Purpose Counter";
	private JLabel lblCounter;
	private JPanel panCenter, panSouth;
	private JButton cbCount, cbReset, cbExit;
	private int numClicks = 0;

	MPCPro() {
		super(titel);

		Container cont = getContentPane();
		
		cbCount = new JButton("Zhlerstand erhhen");
		cbCount.setMnemonic(KeyEvent.VK_S);
		getRootPane().setDefaultButton(cbCount);
		cbCount.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				numClicks++;
				lblCounter.setText(labelPrefix + numClicks);
			}
		});

		cbReset = new JButton("Zhlerstand zurcksetzen");
		cbReset.setMnemonic(KeyEvent.VK_R);
		cbReset.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				numClicks = 0;
				lblCounter.setText(labelPrefix + numClicks);
			}
		});

		cbExit = new JButton("Programm beenden");
		cbExit.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				System.exit(0);
			}
		});
		
		lblCounter = new JLabel(labelPrefix + "0    ");
		lblCounter.setFont(new Font("SansSerif", Font.BOLD, 16));
		
		panCenter = new JPanel();
		panCenter.setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));
		panCenter.setLayout(new GridLayout(0, 1));

		panCenter.add(cbCount);
		panCenter.add(lblCounter);
		
		cont.add(panCenter, BorderLayout.CENTER);

		panSouth = new JPanel();
		panSouth.setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));
		panSouth.setLayout(new GridLayout(1, 0, 5, 5));
		panSouth.add(cbReset);
		panSouth.add(cbExit);
		cont.add(panSouth, BorderLayout.SOUTH);
		
		addWindowListener(new WC());

		setMinimumSize(new Dimension(400, 200));		
		setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
		setSize(400, 200);
		setVisible(true);
	}

	public static void main(String[] args) {
		new MPCPro();
	}

	private class WC extends WindowAdapter {
		public void windowClosing(WindowEvent e) {
			if (JOptionPane.showConfirmDialog(e.getWindow(), 
				  "Wollen Sie das Programm tatschlich beenden?", 
				  titel, JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION)
				System.exit(0);
		}
	}
}
