import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

class Umschalter extends JFrame {
	private JCheckBox chkBold, chkItalic;
	private JRadioButton rbSans, rbSerif, rbMono;
	private JLabel lblBeispiel;
	private JPanel panCheck, panRadio;
	private ButtonGroup rbGroup;

	private Font	fontSans = new Font(Font.SANS_SERIF, Font.PLAIN, 16),
					fontSerif = new Font(Font.SERIF, Font.PLAIN, 16),
					fontMono = new Font(Font.MONOSPACED, Font.PLAIN, 16);
		
	Umschalter() {
		super("JCheckBox und JRadioButton");
		Container cont = getContentPane();
		cont.setLayout(new GridLayout(1, 3));

		panCheck = new JPanel();
		panCheck.setLayout(new GridLayout(0, 1));
		cont.add(panCheck);

		panRadio = new JPanel();
		panRadio.setLayout(new GridLayout(0, 1));
		cont.add(panRadio);
		
		lblBeispiel = new JLabel("Beispieltext");
		cont.add(lblBeispiel);
		lblBeispiel.setFont(fontSerif);
		
		chkBold = new JCheckBox("Fett");
		chkItalic = new JCheckBox("Kursiv");
		panCheck.add(chkBold);
		panCheck.add(chkItalic);

		CheckHandler cbHandler = new CheckHandler();
		chkBold.addItemListener(cbHandler);
		chkItalic.addItemListener(cbHandler);

		rbSans = new JRadioButton("Sans Serif", false);
		rbSerif = new JRadioButton("Serif", true);
		rbMono = new JRadioButton("Monospaced", false);
		
		panRadio.add(rbSans);
		panRadio.add(rbSerif);
		panRadio.add(rbMono);
		
		rbGroup = new ButtonGroup();
		rbGroup.add(rbSans);
		rbGroup.add(rbSerif);
		rbGroup.add(rbMono);
		
		RadioHandler rbHandler = new RadioHandler();
		rbSans.addItemListener(rbHandler);
		rbSerif.addItemListener(rbHandler);
		rbMono.addItemListener(rbHandler);
		
		setDefaultCloseOperation(EXIT_ON_CLOSE);
       
		setSize(550, 140);
		setVisible(true);
	}
	
	public static void main(String[] args) {
		new Umschalter();
	}

	private class RadioHandler implements ItemListener {
		public void itemStateChanged(ItemEvent e) {
			int style = lblBeispiel.getFont().getStyle();
			Font font = null;
			if (e.getSource() == rbMono) {
				font = fontMono;
			} else if (e.getSource() == rbSerif) {
				font = fontSerif;
			} else if (e.getSource() == rbSans) {
				font = fontSans;
			}
			lblBeispiel.setFont(font.deriveFont(style));
		}
	}


	private class CheckHandler implements ItemListener {
		public void itemStateChanged(ItemEvent e) {
			int oldStyle = lblBeispiel.getFont().getStyle(),
				newStyle = 0;
			
			if (e.getSource() == chkBold) {
				if (e.getStateChange() == ItemEvent.SELECTED) {
					newStyle = oldStyle + Font.BOLD;
				} else {
					newStyle = oldStyle - Font.BOLD;
				}
			} else if (e.getSource() == chkItalic) {
				if (e.getStateChange() == ItemEvent.SELECTED) {
					newStyle = oldStyle + Font.ITALIC;
				} else {
					newStyle = oldStyle - Font.ITALIC;
				}
			}
			lblBeispiel.setFont(lblBeispiel.getFont().deriveFont(newStyle));
		}
	}
}